#include <sys/time.h>
#include <math.h>
#include <stream.h>
#include "Ran.h"




random_var::set_state(char* thestate, int bytes = STATESIZE*4)
{
	for( int i = 0; i< STATESIZE; i++)
		state[i] = i;
	initstate(seed,thestate,bytes);
}


random_var:: random_var(double m, double s)
{

	struct timeval tp;
	//cout << "\n constructing seedless ranvar";

	gettimeofday(&tp, (struct timezone*) NULL);
	seed = (int) (tp.tv_usec)*(tp.tv_sec);
	srandom(seed);
	mean = m;
	std = s;
	safe = 0;
	if (safe) set_state( (char*) state, STATESIZE*4);
}

random_var:: random_var(int inseed, double m, double s, int saf = 0 )
{
	//cout << "\n constructing seedy ranvar, safe = " << saf;
	random_var::seed = inseed;
	//cout << "\n inseed = " << inseed;
	//cout << "\n seed = " << seed;
	mean = m;
	std = s;
	safe = saf;
	if (safe) set_state( (char*) state,STATESIZE*4);
	//if (safe) cout << "\n" << state[0] << state[1];
	srandom(seed);

}

void random_var::dump()
{
	cout <<  "\n DUMP:";
	cout << "\n seed: " << seed;
	cout << "\n safe: " << safe;
	cout << "\n std: " << std;
	cout << "\n mean: " <<mean;
	cout << "\n state: " << state[0] << " " << state[1] <<"\n" ;
}

double random_var::sample()
{return 0.0;
}

// seed from clock, cannot be safe

normal :: normal( double m, double s )
: 
( m,s)
{
	iset = 0;
}


normal :: normal(int inseed, double m, double s, int saf = 0 )
: 
(inseed, m,s, saf)
{
	iset = 0;
}


// seed from clock, cannot be safe
uniform :: uniform( double m, double s)
: 
( m,s)
{
	//cout << "\n constructing unsafe 2-arg";
};

// provide seed, safe or not (default not!)
uniform :: uniform(int inseed, double m, double s,int saf = 0)
: 
(inseed, m,s, saf)
{
	//cout << "\n constructing poss safe 3 or 4-arg";
};

// seed from clock, cannot be safe

uni_range::uni_range( double low, double hi ) :
((low+hi)/2.0, (hi - low )/ROOT12)
{
};

// provide seed, safe or not (default not!)
uni_range::uni_range(int inseed, double low, double hi, int saf = 0 ) :
(inseed, (low+hi)/2.0, (hi - low )/ROOT12,saf)
{
};




double normal :: sample()
{
	double fac,u1, u2, v1, v2, s;
	long u;


	if (safe) setstate( (char*) state);

	if (iset == 0)
	{
		s = 0;
		do {
			u = random();
			u1 = (double)u/SAMPLE_SIZE;
			u = random();
			u2 = (double)u/SAMPLE_SIZE;
			v1 = 2*u1 - 1;
			v2 = 2*u2 - 1;
			s = v1*v1 + v2*v2;
		} 
		while (s > 1);

		fac = sqrt((-2*log(s))/s);

		gset = (v1 * fac) ;
		iset = 1;
		v2 =v2*fac*std +mean;
		return v2;
	}
	else
	{
		iset = 0;
		return (gset*std)+mean;
	}
}

double uniform:: sample() {
long u;
double u1;
if (safe) {
	setstate( (char*) state);
}
//if (safe) {cout << "\n"<<state[0] <<state[1] << "\n";}
u = random();
u1 = ((double) u/ SAMPLE_SIZE) -0.5;
u1 =  u1*ROOT12*std+mean;
return u1;
}

