/* to be used with NAB.cc and AB.cc */


#ifndef _NABC_h
#define _NABC_h

// #include <stream.h>
#include "Ran.h"
#include "filt.h"   //the filter param struct, some enum types, same for NAB filters...

/* streamlined alpha-beta-gamma filter.  User must supply his own a-b-c.  I have formulae
for them, probably should supply the ancillary routines to help out */

/* This  supports the Noisy ABC filter, with slots in the f_parms for noise value
that is to be added to the PREDICTION INTERVAL.  So if it thinks it's predicting
at one advance, really it goes to another advance via addition of noise.
Hmm...Should I discretize the noise to ticks?  I think so... */


/* note that if we supplied lambda, then alpha and beta are determined, and
we would hjave a reasonable # of parameters, wouldn't ahve to worry with this struct */

/* the idea of the struct is to simplify the calls, which otherwise
	get cluttered up with lots of parameters.  On the other hand this means
	the user has to do a lot more work...maybe need another layer to protect him.
	Another aspect is that the user has to allocate these records and pass them
	into filter, but they really belong to the filter, who can delete them.  Not
	so nice --- they really should physically  live in the filter...what to do?? */

class abcfilter{

protected:

	filter_params f_params;
	int timeout_ticks;
	double xlast, xcurr, vlast, vcurr, vave;  //for the a-b filter calc.
	double xave, alast, acurr, aave;  // for a-b-c calc.
	double x_pred, v_pred, a_pred, innov; 
	double N;

public:
	filter_activity activity;
	double x_est, v_est, a_est;    //estimated variable
	double x_future, v_future, a_future; //predicted variable at time advance in the future;
					//noisy of course ...heh heh
	int age_ticks;		// total age;
	double age_secs;		// total age;
	int data_ticks; //how long we've seen target
	double data_secs; //how long we've seen target
	int nodata_ticks; // how long we've not seen target
	double nodata_secs; // how long we've not seen target

	// idea was to make all the above public so user could just inquire...

	abcfilter(filter_params parms);  //create and init
	void run(data_type signal, double x, double advance); //assumes runs every tick. 
	void run(data_type signal, double x, double advance, double timestamp);
			// for irregular data arrival
	void dump(void);
};

void F_report(double pl_x, abcfilter F);

#endif
