#ifndef _Ran_h
#define _Ran_h

// this has virtual sample function ...useful.   Use with Ran.cc

const long SAMPLE_SIZE =  2147483647;    // range of random generator

const double ROOT12=  3.4641016151377544;
const int STATESIZE = 32;                //words



class random_var {
	friend class normal;
	friend class uniform;
	friend class  uni_range;

private:

	long state[STATESIZE];
	int seed;
	set_state(char* state, int bytes);
	double mean;
	double std;
	int safe;

public:

	random_var(double m, double s);        // set seed from clock

	random_var(int seed,double m, double s, int saf = 0 );      // set seed manually

	virtual double sample();
	void dump();
};

class normal : public random_var {
int iset;
double gset;

public: 
double sample();
normal(int seed, double m, double s,  int safe = 0 ); 
normal(double m, double s); 
};

class uniform : public random_var {
public: 
double sample();
uniform( int inseed, double m, double s, int saf = 0 );
uniform( double m, double s );

};      

class uni_range : public uniform
{
public:
uni_range( int inseed, double low, double hi, int saf = 0);
uni_range( double low, double hi );
};


#endif
